-- Access the Lightroom SDK namespaces
local catalog = import "LrApplication".activeCatalog()
local LrVers = import "LrApplication".versionTable()
local LrFunctionContext = import 'LrFunctionContext'
local LrBinding = import 'LrBinding'
local LrDialogs = import 'LrDialogs'
local LrView = import 'LrView'
local LrLogger = import 'LrLogger'
local LrColor = import 'LrColor'
local LrErrors  = import 'LrErrors'
local prefs = import 'LrPrefs'.prefsForPlugin() 
local LrTasks = import "LrTasks"
local ProgressScope = import 'LrProgressScope'
local LrShell = import "LrShell"
local LrPathUtils = import "LrPathUtils"
local LrHttp = import "LrHttp"
local LrDate = import "LrDate"
local LRXml = import 'LrXml'

-- functions to update sample data
require 'functions.lua'
require 'ChangeTargetFieldName.lua'
require 'ChangeSourceFieldName.lua'

-- Create the logger and enable the print function
local myLogger = LrLogger('Search replace transfer')
myLogger:enable("logfile") -- Pass either a string or a table of actions
myLogger:trace("ciao") 

-- Create a namespace for the functions
MyHWLibraryItem = {}
if prefs.TimesRun then
else
	prefs.TimesRun  = 0
end
local prefsTimesRun = prefs.TimesRun  
prefs.TimesRunMax = _G.TimesRunMax 

-- Write trace information to the logger
function MyHWLibraryItem.outputToLog(message)
	myLogger:trace(message)
end

function MyHWLibraryItem.showCustomDialog()

	LrFunctionContext.callWithContext("showCustomDialog", function(context)

	local f = LrView.osFactory()
	local cat_photos = catalog.targetPhotos
	
	-- Create a bindable table.  Whenever a field in this table changes
	-- then notifications will be sent. 
	local props = LrBinding.makePropertyTable(context)
	props.editItem = 1
	-- Get preferences and set up property values 
	if prefs.where then
		props.where = prefs.where
		else props.where = 'suffix'
		prefs.where = 'suffix'
		end 
	if prefs.method then 
		props.method = prefs.method 
		else props.method = 'replace' 
		prefs.method = 'replace' 
		end 
	if prefs.targetfield then
		props.targetfield  = prefs.targetfield
		else props.targetfield = 'caption'
		prefs.targetfield = 'caption'
		end 
	if prefs.sourcefield then 
		props.sourcefield  = prefs.sourcefield 
		else props.sourcefield = 'caption' 
		prefs.sourcefield = 'caption' 
		end 
	if prefs.searchfor then 
		props.searchfor  = prefs.searchfor 
		end 
	if prefs.replacewith then 
		props.replacewith  = prefs.replacewith 
		end 
	props.separator = ' ' 
	props.sequence = false 	
-------------text labels
	local staticItem1 = f:static_text {
			title = tostring(props.editItem, 2) .. ' / ' .. #cat_photos ,
			width_in_chars =  8 ,
	}
	local staticItem2 = f:static_text {
			title = tostring(props.editItem, 2) .. ' / ' .. #cat_photos ,
			width_in_chars =  8 ,
			alignment  = 'left',
	}
	local staticItem3 = f:static_text {
			title = tostring(props.editItem, 2) .. ' / ' .. #cat_photos ,
			width_in_chars =  8 ,
			alignment  = 'left',
	}
-----------------------------------------------------iVIew
	local staticIView2 = f:static_text {
			title = '' ,
			width_in_chars =  30 ,
	}
	local staticIView3 = f:static_text {
			title = '3. Process the XML and update matching files' .. "\n" .. '(match based on filename inc extension)' ,
	}
	local myEvent = {}
	local myCustom = {}	
	local myFilepath = {}
	local myFilenames = {}
	local myPeople = {}
	local myColouredLabel = {}
	local myCustom01 = {}
	local myCustom02 = {}
	local myCustom03 = {}
	local myCustom04 = {}
	local myCustom05 = {}
	local myCustom06 = {}
	local myCustom07 = {}
	local myCustom08 = {}
	local myCustom09 = {}
	local myCustom10 = {}
	local myCustom11 = {}
	local myCustom12 = {}
	local myCustom13 = {}
	local myCustom14 = {}
	local myCustom15 = {}
	local myCustom16 = {}
	local xmlCount
	props.ivLabel = true
	props.ivEvent = true
	props.ivPeople = true
-------------------------------------------------------
function staticTarget() 	
	return f:static_text {
			title = longFieldName(prefs.targetfield),
			width = 200 ,
			text_color = LrColor (0, 0.7, 0.7) ,
			font = "<system/bold>",
	}
end
function staticSource() 	
	return f:static_text {
			title = longFieldName(prefs.sourcefield),
			width = 200 ,
			text_color = LrColor (0, 0.7, 0.7) ,
			font = "<system/bold>",
	}
end
	local staticTarget1 = staticTarget() 
	local staticTarget2 = staticTarget() 
	local staticTarget3 = staticTarget() 
	local staticSource = staticSource() 

-----------------major functions-----------------major functions-----------------major functions-----------------major functions
function GetFieldValue(WhichField, photo)		
	local fieldval =''
	WhichFieldType = FieldType(WhichField)
		if WhichFieldType == 'custom' then
			local customFieldName = string.gsub(WhichField,'srt','') 
			if photo:getPropertyForPlugin(_PLUGIN, customFieldName ) ~= nil then
			fieldval  = photo:getPropertyForPlugin(_PLUGIN , customFieldName  )
			end
		elseif WhichFieldType == 'format' then 
			fieldval = photo:getFormattedMetadata(WhichField) 
		elseif WhichFieldType == 'getraw' then 
			fieldval =  photo:getRawMetadata(WhichField) 
		end
	return fieldval  
end 


function SuperSampleBefore(Catalogue,TargetPhotos,WhichField)
	local fieldvals = {}
		local counter = 1
		LrTasks.startAsyncTask( function()	
			catalog:withReadAccessDo( function() 
				for i, photo in ipairs(TargetPhotos) do 
						fieldvals[counter ]  = GetFieldValue(WhichField, photo)  
						counter = counter + 1
				end	
			end) --end Catalogue:withReadAccessDo
		end) -- end LrTasks.startAsyncTask
	return fieldvals
end 

function SampleBefore(Catalogue,TargetPhotos,WhichItem,WhichField)
	LrTasks.startAsyncTask( function()	
	catalog:withReadAccessDo( function() 
		photo = TargetPhotos[WhichItem]
		local txtBefore = GetFieldValue(WhichField, photo)
		txtRows =  4  --#txtBefore / 20 
		end) --end Catalogue:withReadAccessDo
	end) -- end LrTasks.startAsyncTask
	return {txtBefore, txtRows}
end 

function  newSampleAfter(SearchWhat, SearchFor, ReplaceWith)
		if SearchWhat == nil then
		origCaption = ' '
		else
		origCaption = SearchWhat
		end	
		if SearchFor == nil and ReplaceWith == nil then 
			newCaption = origCaption
		else 
			searchfor = string.gsub( SearchFor ,"(%W)", "%%%1") 
			if ReplaceWith == nil then ReplaceWith='' end
			replacewith =  ReplaceWith	
			newCaption = string.gsub (origCaption, searchfor, replacewith )	
			newCaption = string.gsub(newCaption, "%%", "%%%%")	
		end
	return newCaption
end

local targetFieldValues = {}
local sourceFieldValues = {}	
targetFieldValues = SuperSampleBefore(catalog, cat_photos, props.targetfield)
sourceFieldValues = SuperSampleBefore(catalog, cat_photos, props.sourcefield)

function Transfer(photo, item)
	local txtSource = ''
	local txtTarget = ''
	local txtOutput = ''
	txtSource = GetFieldValue(props.sourcefield, photo)		
	txtTarget = GetFieldValue(props.targetfield, photo)	
	if txtSource == nil then txtSource ='' end
	if  props.method  == 'replace' then
		txtOutput =  txtSource
		elseif  props.method  == 'prefix' then
		txtOutput = txtSource .. props.separator .. txtTarget
		elseif  props.method  == 'suffix' then
		txtOutput = txtTarget .. props.separator .. txtSource
	end
	return txtOutput
end 

function PreviewTransfer()
	local txtSource = ' '
	local txtTarget = ' '
	local txtOutput = ' '
	if sourceFieldValues[props.editItem] ~= nil then txtSource = sourceFieldValues[props.editItem] end	
	if targetFieldValues[props.editItem] ~= nil then txtTarget = targetFieldValues[props.editItem] end	
	if props.method == 'replace' then
		txtOutput = txtSource
		elseif props.method == 'prefix' then
		txtOutput = txtSource .. props.separator .. txtTarget
		elseif props.method == 'suffix' then
		txtOutput = txtTarget .. props.separator .. txtSource
	end
	return txtOutput
end 
	
-----------------major functions-----------------major functions-----------------major functions-----------------major functions

	local staticBefore = f:static_text { 
		title = targetFieldValues[props.editItem],		
		height_in_lines = 6,
		width_in_chars = 24,
	}
	local staticAppendPreview = f:static_text { 
		title = staticBefore.title,
		width_in_chars = 24,
		height_in_lines = 6 ,
	}
	local staticAfter = f:static_text { 
		title = newSampleAfter(staticBefore.title ,props.searchfor ,props.replacewith),
		height_in_lines = 6,
		width_in_chars = 24,
	}

	local staticTransferPreview= f:static_text { 
		title = PreviewTransfer(),
		height_in_lines = 8,
		width_in_chars = 24,
	}

---------------------------Function that watches the field choice drop down
local SwitchAppend = function()
	if props.sequence == false then
		txtSeq  = ''
		else
		txtSeq = props.editItem
	end	
	if props.append == nil then
		txtAppend =''
		else
		txtAppend = props.append	
	end	
	if props.where == 'suffix' then
		staticAppendPreview.title = targetFieldValues[props.editItem] .. txtAppend  .. txtSeq
		else 
		staticAppendPreview.title = txtSeq .. txtAppend .. targetFieldValues[props.editItem]
	end	
	staticItem2.title = tostring(props.editItem, 2)	.. ' / ' .. #cat_photos
	staticItem3.title = staticItem2.title 
	staticTransferPreview.title = PreviewTransfer()
end

local SwitchField = function()
	targetFieldValues = SuperSampleBefore(catalog, cat_photos, props.targetfield)
	staticBefore.title = targetFieldValues[props.editItem]
end 

local ChangeSearch = function()
	staticBefore.title = targetFieldValues[props.editItem]
	staticAfter.title = newSampleAfter(staticBefore.title ,props.searchfor ,props.replacewith)
	staticItem1.title = tostring(props.editItem, 2)	.. ' / ' .. #cat_photos
end 

local ChangeSeparator = function()
	staticTransferPreview.title = PreviewTransfer()
end 

props:addObserver('targetfield', SwitchField)
props:addObserver('separator', ChangeSeparator)
props:addObserver('searchfor', ChangeSearch)
props:addObserver('replacewith', ChangeSearch)
props:addObserver('editItem', ChangeSearch)
props:addObserver('editItem', SwitchAppend)
props:addObserver('sourcefield', SwitchAppend)
props:addObserver('append', SwitchAppend)
props:addObserver('where', SwitchAppend)
props:addObserver('method', SwitchAppend)
props:addObserver('sequence', SwitchAppend)
--------------------------------------------------------------------------------------End

function btnChangeTargetFieldDialog ()
	return f:push_button {
		title = LOC "$$$/srt/GetFieldDialog=...",
		tooltip= LOC "$$$/srt/ChangeField=Change field",
		action = function()
			ChangeTargetField ()
			props.targetfield = prefs.targetfield
			targetFieldValues = SuperSampleBefore(catalog, cat_photos, prefs.targetfield)
			staticBefore.title = targetFieldValues[props.editItem]
			staticAfter.title = newSampleAfter(staticBefore.title ,props.searchfor ,props.replacewith)
			staticTarget1.title = longFieldName(prefs.targetfield)			
			staticTarget2.title = longFieldName(prefs.targetfield)
			staticTarget3.title = longFieldName(prefs.targetfield)
			props.editItem = props.editItem + 1 
			props.editItem = props.editItem  - 1 
	end,
	}
end
function btnChangeSourceFieldDialog ()
	return f:push_button {
		title = LOC "$$$/srt/GetFieldDialog=...",
		tooltip= LOC "$$$/srt/ChangeField=Change field",
		action = function()
			ChangeSourceField ()
			props.sourcefield = prefs.sourcefield
			staticSource.title = longFieldName(prefs.sourcefield)	
		    sourceFieldValues = SuperSampleBefore(catalog, cat_photos, props.sourcefield)
			staticTransferPreview.title = PreviewTransfer()
			props.editItem = props.editItem + 1 
			props.editItem = props.editItem  - 1 
	end,
	}
end

local btnChangeTargetFieldDialog1 = btnChangeTargetFieldDialog ()
local btnChangeTargetFieldDialog2 = btnChangeTargetFieldDialog ()
local btnChangeTargetFieldDialog3 = btnChangeTargetFieldDialog ()
local btnChangeSourceFieldDialog1 = btnChangeSourceFieldDialog ()

function btnRefresh()
	return f:push_button {
		title = LOC "$$$/srt/GetFieldDialog=!",
		tooltip= LOC "$$$/srt/Refresh=Refresh",
		action = function()
			props.editItem = props.editItem + 1 
			props.editItem = props.editItem  - 1 
		end,
	}
end

local btnRefresh1= btnRefresh()
local btnRefresh2= btnRefresh()
local btnRefresh3= btnRefresh()
-------------------------------------------------------------------------------------------------------------------------------------------

function ItemSlider()
	return 
	f:row {
		f:push_button { 
			title = '<',
			enabled = PreviewEnabled(#cat_photos),
			action = function()
			if props.editItem == 1 then
			props.editItem = #cat_photos		
			else
			props.editItem = props.editItem - 1
			end
			end
		},
		f:slider {
			value = LrView.bind("editItem"),
			min = 1,
			max = #cat_photos,
			integral = true,
			enabled = PreviewEnabled(#cat_photos),
		},
		f:push_button { 
			title = '>',
			enabled = PreviewEnabled(#cat_photos),
			action = function ()
			if props.editItem == #cat_photos then	
				props.editItem = 1
				else
				props.editItem = props.editItem + 1
				end		
			end
		}
	}
end

local ItemSlider1 = ItemSlider()
local ItemSlider2 = ItemSlider()
local ItemSlider3 = ItemSlider()


---Start--------------------------------------------------------------------Documentation and Download --------------------
	local documentation = f:push_button {
		title = LOC "$$$/OpenDirectly/Documentation=Documentation (PDF)",
		enabled = true,
		action = function()
			if WIN_ENV == true then
				LrTasks.execute('"' .. _PLUGIN:resourceId('DocumentationBeardyReplace.pdf') .. '"')
			else
				LrShell.openFilesInApp( { LrPathUtils.child(_PLUGIN.path,'DocumentationBeardyReplace.pdf') }, '/Applications/Preview.app' )
			end
		end,
	}

	local downloadpage = f:push_button {
		title = LOC "$$$/OpenDirectly/DownloadPage=DownloadPage",
		enabled = true,
		visible = false,
		action = function()
			LrHttp.openUrlInBrowser( _G.pluginURL )
		end,
	}

	local staticVersion = f:static_text { 
				title = ' ',
				width =450,
				height_in_lines = 3, 
		}

	function LatestVersion()
		LrTasks.startAsyncTask(function()
			local response = ''
			local url = _G.pluginVersionURL			
			response = LrHttp.get( url )
			if response == nil then return false end
			if response ~= _G.pluginVersion then
			staticVersion.title =  'The latest version of this plug-in is ' .. response .. '. You are running version ' .. _G.pluginVersion .. '.'	
			downloadpage.visible = true
			else
			staticVersion.title = ' '
			end
		end)	
	end
	LatestVersion()
--End---------------------------------------------------------------------Documentation and Download --------------------

	-- Create the contents for the dialog.
	
		local c = f:row {
		
			-- bind the table to the view.  This enables controls to be bound 
			-- to the named field of the 'props' table.
			bind_to_object = props,

			f:column {

			f:row {
						staticVersion,	
						f:column{
						--spacing =  f:control_spacing(),
						downloadpage,
						--documentation,	
						},
				},

				f:tab_view
				{				
					f:tab_view_item{	
						identifier = "tab1",
						title = LOC "$$$/SearchReplace/ReplaceTab=Search + replace",		
						f:row{	
							margin_top = 10,
							f:group_box
							{
								font = "<system>",
								title = LOC "$$$/SearchReplace/TargetField=Target field : ",
								f:row{
									staticTarget1,
									btnChangeTargetFieldDialog1,
									btnRefresh1,
								},
							},
						},

						f:row{
							margin_top = 5,
							f:group_box{
								font = "<system>",
								title = LOC '$$$/SearchReplace/SearchFor=Search for:',
								f:row{		
									f:edit_field{
										value = LrView.bind("searchfor"),
										fill_horizontal = 1.0,
										immediate = true,
									},
								},
								f:row{							
									staticBefore,
								},
							}, -- end of group box
							f:group_box{
								font = "<system>",
								title = LOC "$$$/SearchReplace/ReplaceWith=Replace with:",
								f:row{		
									f:edit_field{
										value = LrView.bind("replacewith"),
										fill_horizontal = 1.0,
										immediate = true,
									},
								},
								f:row{
									staticAfter,
								}
							} --end of group box
						},	--end of row

						f:row{
							ItemSlider1,
							staticItem1,
							--},
							f:push_button {
								title = LOC '$$$/SearchReplace/Nagging1/buttonpfx=Search and replace ' .. #cat_photos .. LOC '$$$/SearchReplace/Nagging1/buttonsfx= item(s)',
								tooltip = MacTab (),
								enabled = true,
								place_horizontal = .95,
								action = function()
									prefs.TimesRun  =  prefs.TimesRun  + 1
									prefs.where = props.where
									prefs.method = props.method	
									prefs.targetfield = props.targetfield 
									prefs.sourcefield = props.sourcefield
									prefs.searchfor = props.searchfor;
									prefs.replacewith = props.replacewith;
					
									MyHWLibraryItem.outputToLog("Search and replace text")
									local ProgressScope = ProgressScope({
										title = 'Search and replace',
										caption = '',
									})
									LrTasks.startAsyncTask(function()
									catalog:withWriteAccessDo( "Search and replace text", function()									
										if prefs.TimesRun > prefs.TimesRunMax then
											str_1  = LOC "$$$/SearchReplace/Nagging1=You've reached the number of times the demo version can be run:" .. prefs.TimesRunMax .. "\n"
											str_2  = LOC "$$$/SearchReplace/Nagging2=To buy the full version, go to the Info tab or to File > PlugIn Manager"		
											LrDialogs.message( str_1 .. "\n" .. str_2)										
										else
										local cat_photos = catalog.targetPhotos
											-- loop through each of the photos
											local lrItem = 1
											local lrCount  = #cat_photos
											for i, photo in ipairs(cat_photos) do 
												local loopbefore = ""		
												loopbefore = targetFieldValues[lrItem]			
												newCaption = newSampleAfter(loopbefore ,props.searchfor ,props.replacewith)
												lrItem = lrItem + 1
												ProgressScope:setPortionComplete(lrItem/lrCount)
												ProgressScope:setCaption("..." .. lrItem .. "/" .. lrCount)
												if  props.searchfor ~=  nil then									
													if string.sub(props.targetfield,1,3) == 'srt' then
														local srttargetfield = string.gsub (props.targetfield, 'srt' , '' )	
														photo:setPropertyForPlugin(_PLUGIN, srttargetfield , newCaption )
														else
														photo:setRawMetadata(props.targetfield, newCaption )
													end										
												end
											end
										end --end if
									end) -- end withWriteAccessDo
									end) -- end the task	
								ProgressScope:done() 
								end,
							},
						},
					},		

					f:tab_view_item{	
						identifier = "tab2",
						title = LOC "$$$/SearchReplace/AppendTab=Append",
						f:row{	
							f:column
							{
									f:group_box{										
										font = "<system>",
										title = LOC "$$$/SearchReplace/TargetField=Target field : ",
										f:row{	
										staticTarget2,
										btnChangeTargetFieldDialog2,
										},
									},
								f:row{					
									margin_top = 10,
									f:group_box{										
										title = LOC "$$$/SearchReplace/Add=Add text : ",
										font = "<system>",
											f:row{					
												f:static_text { 
													title = 'Text : ',
													width =LrView.share( 'label_width' ) ,
												},
												f:edit_field{
													value = LrView.bind('append'),
													immediate = true,
												},
											},					
											f:row {
													spacing = f:control_spacing(),							
													f:static_text { 
														title = LOC "$$$/Radio/Where=Where : " ,
														width =LrView.share( 'label_width' ) ,
													},
													f:radio_button {
														title = LOC "$$$/Radio/Prefix=Before",
														value = LrView.bind("where"),
														checked_value = "prefix",
													},							
													f:radio_button {
														title = LOC "$$$/Radio/Suffix=After",
														value = LrView.bind("where"),
														checked_value = 'suffix',
													},					
											},
									},	
								}, --end row
								f:row{	
									margin_top = 10,
									f:group_box{							
										font = "<system>",
										title = LOC "$$$/SearchReplace/Seq=Seq no : ",
										f:row{		
											f:checkbox{
												value =  LrView.bind("sequence"),
												},
											},
										},--end group box									
								}, --end row
							},
							f:group_box{										
								title = LOC "$$$/SearchReplace/Result=Result : ",
								font = "<system>",
								f:row{
								staticAppendPreview,
								btnRefresh2,
								},
								f:row{
								ItemSlider2,
								staticItem2,
								},
							}, --end group
						},
					
						f:row{		
							margin_top = 10,
							f:push_button {
								title = LOC "$$$/SearchReplace/AppendTab=Append text to " .. #cat_photos .. LOC '$$$/SearchReplace/Nagging1/buttonsfx= item(s)',	
								enabled = true,
								tooltip = MacTab(),
								place_horizontal = .95,
								action = function()
									prefs.TimesRun  =  prefs.TimesRun  + 1	
									--save last used target and source fields
									prefs.where = props.where
									prefs.method = props.method	
									prefs.targetfield = props.targetfield 
									prefs.sourcefield = props.sourcefield

									MyHWLibraryItem.outputToLog("Append text")
									LrTasks.startAsyncTask( function()
										catalog:withWriteAccessDo( "Append text", function()
											if prefs.TimesRun > prefs.TimesRunMax then
												str_1  = LOC "$$$/SearchReplace/Nagging1=You've reached the number of times the demo version can be run:" .. prefs.TimesRunMax .. "\n"
												str_2  = LOC "$$$/SearchReplace/Nagging2=To buy the full version, go to the Info tab or to File > PlugIn Manager"		
												LrDialogs.message( str_1 .. "\n" .. str_2)										
											elseif props.append ~= nil or props.sequence == true then
												local cat_photos = catalog.targetPhotos
												local counter = 1
												-- loop through each of the photos		
												for i, photo in ipairs(cat_photos) do 
													local origCaption =  GetFieldValue(props.targetfield, photo)	
													local appendstring = string.format('%s', props.append) 
													if props.sequence == false then
														txtSeq  = ''
														else
														txtSeq = counter
														end	
														counter = counter + 1
													if props.where ==  'prefix' then
														newCaption = appendstring .. origCaption
														else 
														newCaption =  origCaption .. appendstring .. txtSeq
													end
													if string.sub(props.targetfield,1,3) == 'srt' then
														local srttargetfield = string.gsub (props.targetfield, 'srt' , '' )	
														photo:setPropertyForPlugin(_PLUGIN, srttargetfield , newCaption )
														else
														photo:setRawMetadata(props.targetfield, newCaption )
													end																						
												end
											end
										end) -- end withWriteAccessDo
									end) -- end LrTasks.startAsyncTask
									targetFieldValues = SuperSampleBefore(catalog, cat_photos, props.targetfield)
								end,
							},
						},
					},		

					f:tab_view_item{	
						identifier = "tab3",
						title = LOC "$$$/Transfer/Tab1=Transfer",		
						f:row{
							f:column{					
								f:group_box{					
									font = "<system>",
									title = LOC "$$$/SearchReplace/CopyFrom=Copy from : ",
									f:row{					
										staticSource,
										btnChangeSourceFieldDialog1,
									},
								}, --end group box
								f:group_box{					
									font = "<system>",
									title = LOC "$$$/SearchReplace/CopyTo=Copy to : ",
									f:row{					
										staticTarget3,
										btnChangeTargetFieldDialog3,
									},
								}, --end group box
							
								f:group_box{					
									font = "<system>",
									title = LOC "$$$/SearchReplace/Method=Where : ",
									f:row {
											f:radio_button {
												title = LOC "$$$/Radio/Replace=Replace",
												value = LrView.bind("method"),
												checked_value = "replace",
												},							
											f:radio_button {
												title = LOC "$$$/Radio/Prefix=Add before",
												value = LrView.bind("method"),
												checked_value = "prefix",
												},							
											f:radio_button {
												title = LOC "$$$/Radio/Suffix=Add after",
												value = LrView.bind("method"),
												checked_value = 'suffix',
												},					
									},							
								}, --end group box							
								f:group_box{							
									font = "<system>",
									title = LOC "$$$/SearchReplace/Separator=Separator : ",
									f:row{		
										f:edit_field{
											value = LrView.bind("separator"),
											fill_horizontal = 1.0,
											width_in_chars =  8 ,
											immediate = true,
											},
										f:static_text {
												title =  LOC "$$$/SearchReplace/Default=Default = space"
										},
									},--end group box											
								}, --end group box						
							},						
							f:column{
								f:group_box{
									font = "<system>",
									title = LOC "$$$/SearchReplace/Preview=Preview : ",
										f:row{
										staticTransferPreview,
										btnRefresh3,
										}, --end of row
										f:row{
											f:column{
											ItemSlider3,
											},
											f:column{
											staticItem3,
											},
										}, --end of row
								}, --end group box
							},						
						}, --end of row

						f:row{					
							f:static_text { 
								title = ' '  ,			
								width = LrView.share( 'label_width' ),
							},
							f:push_button {
								title = LOC "$$$/SearchReplace/AppendTab=Transfer between fields "  .. #cat_photos .. LOC '$$$/SearchReplace/Nagging1/buttonsfx= item(s)',	
								enabled = true,
								place_horizontal = .95,
								action = function()
									prefs.TimesRun  =  prefs.TimesRun  + 1	
									--save last used target and source fields
									prefs.where = props.where
									prefs.method = props.method	
									prefs.targetfield = props.targetfield 
									prefs.sourcefield = props.sourcefield
									MyHWLibraryItem.outputToLog("Transfer between fields")
									LrTasks.startAsyncTask(function()
										catalog:withWriteAccessDo( "Transfer between fields", function()
											if prefs.TimesRun > prefs.TimesRunMax then
												str_1  = LOC "$$$/SearchReplace/Nagging1=You've reached the number of times the demo version can be run:" .. prefs.TimesRunMax .. "\n"
												str_2  = LOC "$$$/SearchReplace/Nagging2=To buy the full version, go to the Info tab or to File > PlugIn Manager"		
												LrDialogs.message( str_1 .. "\n" .. str_2)										
											else
												local cat_photos = catalog.targetPhotos
												local counter = 1
												-- loop through each of the photos		
												for i, photo in ipairs(cat_photos) do 	
													--origCaption = SampleBefore(catalog, cat_photos, i , props.targetfield)[1]
													newCaption = Transfer(photo,counter)
													if string.sub(props.targetfield,1,3) == 'srt' then
														local srttargetfield = string.gsub (props.targetfield, 'srt' , '' )	
														photo:setPropertyForPlugin(_PLUGIN, srttargetfield , newCaption )
														else
														photo:setRawMetadata(props.targetfield, newCaption )
													end																						
												end
											end
										end)
									end)
								end,
							},
						},
					},		

					f:tab_view_item{
						identifier = "tabIView",
						title = 'iView / Ex Media',	
							f:row {
								f:static_text {
									title = 'This tab is for iView or Expression Media users migrating metadata to Lightroom.\n \n1. Export an XML file from iView/ExMedia by choosing the menu command\n Make > XML File and saving the file to your desktop' ,
								}
							},
							f:row {	
								f:static_text { 
								title = '2. Identify iView or Expression Media XML file'  ,			
								width = LrView.share( 'col_width' ),
								},
								f:push_button {
								title = 'File',
								enabled = true,
								action = function()
									FileStr= LrDialogs.runOpenPanel( 
										{
											title =  'Load iView or Expression Media XML file',
											prompt = 'Load',
											fileTypes = 'xml',
											canChooseFiles = true,
											canChooseDirectories = false,
											canCreateDirectories = false,
											allowsMultipleSelection = false,
										}
									)
     							    --myLogger:trace('Got: ' .. FileStr[1])
									staticIView2.title = 'Parsing XML, please wait....' 
									Hnd, ErrStr = io.open(FileStr[1], "r")
									if Hnd then
										xmlString = Hnd:read("*a")
										staticIView2.title = 'Parsing XML, please wait....' 
										--myLogger:trace( xmlString ) 
										xmlObject = LRXml.parseXml(xmlString)		
										--myLogger:trace( 'Parsed') 
										--myLogger:trace( xmlObject:name() .. ' / ' .. xmlObject:childCount()) 
										for j=1, xmlObject:childCount() do
											xmlObjectItem = xmlObject:childAtIndex(j)	
												if xmlObjectItem:name() == 'MediaItemList' then
												xmlMediaItemList = xmlObject:childAtIndex(j)	
	--~ 											myLogger:trace('xmlMediaItemList name: ' .. xmlMediaItemList:name()  .. ' items:' .. xmlMediaItemList:childCount() )  
												end
										end
										xmlCount = xmlMediaItemList:childCount()
										for x=1, xmlMediaItemList:childCount() do
											staticIView2.title = 'Parsing XML, please wait....'  .. x
											MediaItem = xmlMediaItemList:childAtIndex(x)
	--~ 										myLogger:trace( 'MediaItem: ' .. MediaItem:name() .. '  has children: ' .. MediaItem:childCount()   ) 	
											---------------------------------------------------
											for y=1, MediaItem:childCount() do
												xmlNode = MediaItem:childAtIndex(y)											
												if xmlNode:name() == 'AssetProperties' then
													AssetProperties = xmlNode
													for z=1, AssetProperties:childCount() do
														xmlLeaf = AssetProperties:childAtIndex(z)	
														if xmlLeaf:name() == 'Filepath' then myFilepath[x]  = xmlLeaf:text() end
														if xmlLeaf:name() == 'Filename' then myFilenames[x] = xmlLeaf:text() end
														--if xmlLeaf:name() == 'Filepath' then myLogger:trace(x .. ' : ' .. xmlLeaf:text() ) end											
														if xmlLeaf:name() == 'Label' then myColouredLabel[x]  =  LabelConversion (xmlLeaf:text()) end
													end
												--myLogger:trace(  myFilepath[x]  .. '     ' .. myColouredLabel[x]  )
												elseif xmlNode:name() == 'AnnotationFields' then
													AnnotationFields = xmlNode
													myPeople[x] = ''
													for z=1, AnnotationFields:childCount() do
														xmlLeaf = AnnotationFields:childAtIndex(z)	
														if xmlLeaf:name() == 'Fixture' then myEvent[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'People' then myPeople[x] = myPeople[x] .. '; ' ..  xmlLeaf:text()  end												
													end
													myPeople[x] = string.sub (myPeople[x], 3)
												 elseif xmlNode:name() == 'UserFields' then
													UserFields = xmlNode
													for z=1, UserFields:childCount() do
														xmlLeaf = UserFields:childAtIndex(z)	
--~ 														require 'iView.lua'
														if xmlLeaf:name() == 'UserField_1' then myCustom01[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_2' then myCustom02[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_3' then myCustom03[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_4' then myCustom04[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_5' then myCustom05[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_6' then myCustom06[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_7' then myCustom07[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_8' then myCustom08[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_9' then myCustom09[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_10' then myCustom10[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_11' then myCustom11[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_12' then myCustom12[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_13' then myCustom13[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_14' then myCustom14[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_15' then myCustom15[x] = xmlLeaf:text()  end
														if xmlLeaf:name() == 'UserField_16' then myCustom16[x] = xmlLeaf:text()  end																											
													end
												end
											end
											---------------------------------------------------		
										end -- end of looping through	
										staticIView2.title = 'XML parsed' 
									else								
									myLogger:info('Error' .. ErrStr)								
									end
									Hnd:close()
								end,
								},
							}, -- end f:row
							f:row {						
								staticIView2,
							},
							f:row {						
								f:checkbox{
										value =  LrView.bind("ivLabel"),
										title =  LOC "$$$/SearchReplace/ivLabel=Label" ,
										},						
								f:checkbox{
										value =  LrView.bind("ivEvent"),
										title =  LOC "$$$/SearchReplace/ivEvent=Event" ,
										},						
								f:checkbox{
										value =  LrView.bind("ivPeople"),
										title =  LOC "$$$/SearchReplace/ivPeople=People" ,
										},						
							},
							f:row {
								staticIView3,
								f:push_button {
								title = 'Process',
								enabled = true,
								action = function()
									import "LrTasks".startAsyncTask( function()
									catalog:withWriteAccessDo( "View keywords", function()
									local cat_photos = catalog.targetPhotos
									getData = ''
										for i, photo in ipairs(cat_photos) do 
											getData = photo:getFormattedMetadata('fileName')										
											for i=1,xmlCount do
												myItem = myFilenames[i]
												if getData == myItem then
													if props.ivLabel == true then photo:setRawMetadata('label', myColouredLabel[i] ) end
													if props.ivEvent == true then photo:setPropertyForPlugin( _PLUGIN, 'event', myEvent[i] ) end
													if props.ivPeople == true then photo:setPropertyForPlugin( _PLUGIN, 'people', myPeople[i]) end
													photo:setPropertyForPlugin( _PLUGIN, 'custom01', myCustom01[i] )
													photo:setPropertyForPlugin( _PLUGIN, 'custom02', myCustom02[i] )
													photo:setPropertyForPlugin( _PLUGIN, 'custom03', myCustom03[i])	
													photo:setPropertyForPlugin( _PLUGIN, 'custom04', myCustom04[i] )
													photo:setPropertyForPlugin( _PLUGIN, 'custom05', myCustom05[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom06', myCustom06[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom07', myCustom07[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom08', myCustom08[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom09', myCustom09[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom10', myCustom10[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom11', myCustom11[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom12', myCustom12[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom13', myCustom13[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom14', myCustom14[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom15', myCustom15[i] )			
													photo:setPropertyForPlugin( _PLUGIN, 'custom16', myCustom16[i] )								
												end
											end			
										end		
									end)			
									end ) --------------end of task
								end}	
							},
					},--end of tab
				
					f:tab_view_item{
						identifier = "tab4",
						title = "Info",	
							f:row {	
								margin_bottom = 10,		
								fill_horizontal  = 1,
								f:static_text {
								title = _G.Info6 .. prefsTimesRun .. _G.Info7 ..  _G.Info8 .. prefs.TimesRunMax  .. _G.Info9,
								width_in_chars = 45,
								height_in_lines = 2,
								},
							}, -- end f:row
							f:row {	
								margin_bottom = 10,		
								fill_horizontal  = 1,
								f:static_text {
								title = _G.Info1 ..  _G.Info2 .. _G.Info3 ..   _G.Info4 ,
								height_in_lines = 6,
								width_in_chars = 45,
								},
							}, -- end f:row 

							f:row {
								f:push_button {
									--width = 100,
									title = 'John\'s web site',
									enabled = true,
									action = function()
										LrHttp.openUrlInBrowser(_G.URL)
									end,
								},

								f:push_button {
									--width = 130,
									title = 'Documentation (PDF)',
									enabled = true,
									action = function()
										if WIN_ENV == true then
											LrTasks.execute('"' .. _PLUGIN:resourceId(_G.PDF) .. '"')
										else
											LrShell.openFilesInApp( { LrPathUtils.child(_PLUGIN.path,_G.PDF) }, '/Applications/Preview.app' )
										end
									end,
								},
								f:push_button {
									--width = 120,
									title = 'John\'s Amazon list',
									enabled = true,
									action = function()
										LrHttp.openUrlInBrowser(_G.Amazon)
									end,
								},
							},
					}, -- end tab

				}, -- end tab view


		}, ---end column
	}

	dialogValue = LrDialogs.presentModalDialog(
		{
			title =   _G.pluginLongName,
			contents = c,
--~ 			actionVerb = LOC "$$$/SearchReplace/Action=Change target field",
--~ 			cancelVerb = LOC "$$$/SearchReplace/Source=Change source field",
--~ 			otherVerb = LOC "$$$/SearchReplace/Close=Close",
		}
	)

	end) -- end main function

return dialogValue

end

function MacTab ()
	if WIN_ENV == true then
	return ''
	else
	return LOC '$$$/SearchReplace/Proceed1=Mac users : press TAB key to activate the button'
	end
end

function LabelConversion(labelVal)
	--myLogger:trace( labelVal ) 
	local retVal
	if labelVal == '1' then 
		retVal = 'Red'
	elseif labelVal == '2' then
		retVal = 'Green'
	elseif labelVal == '3' then
		retVal = 'Blue'
	elseif labelVal == '4' then
		retVal = 'Brown'
	elseif labelVal == '5' then
		retVal = 'Purple'
	elseif labelVal == '6' then
		retVal = 'Orange'
	elseif labelVal == '7' then
		retVal = 'Yellow'
	elseif labelVal == '8' then
		retVal = 'Cyan'
	elseif labelVal == '9' then
		retVal = 'Gray'
	else
		retVal = ''	
	end
	return retVal
end



-- Now display the dialogs
local myVal = MyHWLibraryItem.showCustomDialog()